--------------------------------------------------------------------------------
--  avatar_class.lua is part of ZS Shaiya Bot.
--
--  ZS Shaiya Bot is free software: you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation, either version 3 of the License, or
--  (at your option) any later version.
--
--  ZS Shaiya Bot is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with ZS Shaiya Bot.  If not, see <http://www.gnu.org/licenses/>.
--
--  Copyright  2008 ZS Shaiya Bot
--------------------------------------------------------------------------------

-- Avatar_class was intended as an abstract class. You derive a class from this,
-- and implement it's methods.

-- Constuctor.
Avatar_class = class(
  function(obj)
    --obj.type = type;
  end
)

-- battle_round_start The action taken by the avatar when battle against a
--    target has begun.
function Avatar_class:battle_round_start()
  --print("Avatar_class:battle_round_start()")
  return false
end

-- battle_round The action taken by the avatar, at each round.
function Avatar_class:battle_round()
  g_avatar:check_use_buffs(buffs)
  local l_res = nil
  for key, skill in ipairs(g_avatar.skill) do
    l_res = g_avatar:check_use_skill(skill)
    if (l_res) then
      return l_res
    end
  end
  g_avatar:check_use_attack()
  return l_res
end

function Avatar_class:idle_period()
    g_avatar:check_cancel_player_requests()
    g_avatar:check_use_buffs(buffs)
end
