--------------------------------------------------------------------------------
--  potion.lua is part of ZS Shaiya Bot.
-- 
--  ZS Shaiya Bot is free software: you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation, either version 3 of the License, or
--  (at your option) any later version.
-- 
--  ZS Shaiya Bot is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
-- 
--  You should have received a copy of the GNU General Public License
--  along with ZS Shaiya Bot.  If not, see <http://www.gnu.org/licenses/>.
-- 
--  Copyright  2008 ZS Shaiya Bot
--------------------------------------------------------------------------------

-- TODO - Potion available is broken, value to compare needs to be updated each check.

-- Potion this is a sub-class from Shortcuts.
-- shortcut_key Shortcut key(s) of the potion.

--POTION_CHARGE_TIME  = 26;

--[[
    A shortcut to a potion, that gives your hp, mp, sp or all.
    The Potion class is derived from the Shortcut class.
    @param shortcut_key A table of shortcut keys.
    @param cooldown The time it takes for the potion to cooldown
    @param data a hash table containing the bar as the key,
        and the decimal percentage when to use it. (0.5 = 50%).
]]
Potion = class(Shortcut,
  --function (obj, shortcut_key, cooldown, data)
  function (obj, shortcut_key, cooldown, mode, tolerance)
    Shortcut.init(obj, shortcut_key, cooldown)
    --obj.bar = data
    
    obj.mode = mode

    obj.tolerance = (tolerance / 100) -- convert into decimal form
    
    --[[for k,v in ipairs(data) do
      table.insert(obj.bar, v)
      obj.bar.maximum = v.maximum
      obj.bar.threshold = v.threshold
    end]]
  end
)

-- available Check if the potion is available.

-- @returns bool true is potion is available, false otherwise.
function Potion:ready(avi)
  --debug_message("Potion:ready() called")
  local l_time_elapsed = os.difftime(os.time() - self.timer)
  if (l_time_elapsed >= self.cooldown) then
    -- when mode is all cycle through all bars, and check.
    if (self.mode == "all") then
    else
        --print("avi[" .. self.mode .. "]: " .. avi[self.mode])
        --print("avi[" .. self.mode .. "_max]: " .. avi[self.mode .. "_max"])
        --print("tolerance: ", self.tolerance)
        if (avi[self.mode] > (avi[self.mode .. "_max"] * self.tolerance)) then
            return false;
        end
    end

    --[[for k,v in pairs(self.bar) do
      --debug_message("potion - type: " .. avi[k] .. ", tolerance: " .. v)
      if (avi[k] > (avi[(k .. "_max")] * v)) then
        return false;
      end
    end]]
    --debug_message("Potion:available() - is available.")
    return true;
  else
    return false;
  end
end

-- use Use the potion.
function Potion:use()
  debug_message("potion - use()");
  local l_gui = get_gui();
  self.timer = os.time();
  for i,v in ipairs(self.shortcut_key) do
    keyboardPress(v);
    if (l_gui:in_latest_text_msg(GUI_TEXT_MESSAGE_CANNOT_USE_ITEM)) then
      debug_message("potion - cannot use item");
      return;
    end
  end
end
